/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Ryu.xs. Do not edit this file, edit Ryu.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Ryu.xs"
#ifdef  __MINGW32__
#ifndef __USE_MINGW_ANSI_STDIO
#define __USE_MINGW_ANSI_STDIO 1
#endif
#endif

#define PERL_NO_GET_CONTEXT 1

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <ryu.h>
#include <ryu_parse.h>

#if defined(COMPILER_HAS_UINT128_T) && !defined(AVOID_GENERIC_128)
#  include <generic_128.h>    /* modified to include stdbool.h */
#  include <ryu_generic_128.h>
#  include <stdbool.h>
#  ifdef USE_QUADMATH
#    include <quadmath.h> /* do we actually need this ? */
#  endif
#endif

#define QUAD_MANTISSA_BITS 112
#define QUAD_EXPONENT_BITS 15

#include "math_ryu_include.h"

typedef struct floating_decimal_128 t_fd128;

#if defined(COMPILER_HAS_UINT128_T) && !defined(AVOID_GENERIC_128)
struct floating_decimal_128 quad_to_fd128(NV d) {
  uint128_t bits = 0;
  memcpy(&bits, &d, sizeof(NV));
  return generic_binary_to_decimal(bits, QUAD_MANTISSA_BITS, QUAD_EXPONENT_BITS, false);
}
#endif

double _s2d(char * buffer) {
#if NVSIZE == 8
  double nv;
  s2d(buffer, &nv);
  return nv;
#else
  PERL_UNUSED_ARG(buffer);
  croak("s2d() is available only to perls whose NV is of type 'double'");
#endif
}

SV * M_RYU_d2s(pTHX_ SV * nv) {
#if NVSIZE == 8
  return newSVpv(d2s(SvNV(nv)), 0);
#else
  PERL_UNUSED_ARG(nv);
  croak("d2s() is available only to perls whose NV is of type 'double'");
#endif
}

SV * ld2s(pTHX_ SV * nv) {
#if MAX_DEC_DIG == 21
  char * buff;
  SV * outsv;

  Newxz(buff, LD_BUF, char); /* LD_BUF defined in math_ryu_l)include.h, along with D_BUF and F128_BUF */

  if(buff == NULL) croak("Failed to allocate memory for string buffer in ld2s sub");
  generic_to_chars(long_double_to_fd128(SvNV(nv)), buff);
  outsv = newSVpv(buff, 0);
  Safefree(buff);
  return outsv;
#else
  PERL_UNUSED_ARG(nv);
  croak("ld2s() is available only to perls whose NV is of type 80-bit extended precision 'long double'");
#endif
}

SV * q2s(pTHX_ SV * nv) {
#if MAX_DEC_DIG == 36
  char * buff;
  SV * outsv;

   Newxz(buff, F128_BUF, char);

  if(buff == NULL) croak("Failed to allocate memory for string buffer in ld2s sub");
  generic_to_chars(quad_to_fd128(SvNV(nv)), buff);
  outsv = newSVpv(buff, 0);
  Safefree(buff);
  return outsv;
#else
  PERL_UNUSED_ARG(nv);
  croak("q2s() is available only to perls whose NV is either '__float128' or IEEE 754 'long double'");
#endif
}

int _SvIOK(SV * sv) {
    if(SvIOK(sv)) return 1;
    return 0;
}

int _SvNOK(SV * sv) {
    if(SvNOK(sv)) return 1;
    return 0;
}

int _SvPOK(SV * sv) {
    if(SvPOK(sv)) return 1;
    return 0;
}

int _SvIOKp(SV * sv) {
    if(SvIOKp(sv)) return 1;
    return 0;
}

int ryu_lln(pTHX_ SV * sv) {
  return looks_like_number(sv);
}

int _compiler_has_uint128(void) {
#ifdef COMPILER_HAS_UINT128_T
   return 1;
#else
   return 0;
#endif
}

int _get_max_dec_dig(void) {
#ifdef MAX_DEC_DIG
   return MAX_DEC_DIG;
#else
   return 0;
#endif
}

SV * fmtpy(pTHX_ SV * in) {
  int is_neg = 0, pointpos = 0, exponent, dec = 0, zero_pad = 0;
  char *man_str, *exp_str;
  size_t i, len, seen = 0;
  char *s = SvPV_nolen(in);
  SV * outsv;

  if(s[0] == '-') {
    is_neg = 1;
    s++;
  }

  /* If the given argument contains a decimal point, then that *
   * decimal point will immediately follow the first digit.    *
   * Otherwise, the argument does not contain a decimal point. */
  if(s[1] == '.') pointpos = 1;

  if(pointpos) {
    /*** STRING CONTAINS A DECIMAL POINT ***/
    Newxz(man_str, MAN_BUF, char);
    if(man_str == NULL) croak("Failed (in 'if' block) to allocate memory for man_str in fmtpy function");
    Newxz(exp_str, EXP_BUF, char);
    if(exp_str == NULL) croak("Failed (in 'if' block) to allocate memory for exp_str in fmtpy function");

    /* Split into mantissa and exponent around 'E'         *
     * The input string (s) has the 'E' replaced by a NULL *
     * and the exponent portion of s is copied to exp_str  */
    len = strlen(s);
    for(i = 0; i < len; i++) {
      if(seen) { /* will be set when 'E' is encountered' */
        exp_str[i - seen] = s[i];
      }
      else if(s[i] == 'E') {
        seen = i + 1;
        s[i] = '\0';
      }
    }
    exp_str[i - seen] = '\0';
    exponent = atoi(exp_str);

    if(exponent > 0 && exponent < MAX_DEC_DIG) {
      len = strlen(s);
      zero_pad = exponent - (len - 2);
      if(zero_pad >= 0 && (zero_pad + len < MAX_DEC_DIG + 1)) {
        /* Return, eg, '1.23E15' as '1230000000000000.0' */
        if(is_neg) man_str[0] = '-';
        man_str[0 + is_neg] = s[0];
        for(i = 2; i < len; i++) {
          man_str[i + is_neg - 1] = s[i];
        }
        for(dec = 0; dec < zero_pad; dec++) {
          man_str[i + is_neg - 1] = '0';
          i++;
        }
        man_str[i + is_neg - 1] = '.';
        man_str[i + is_neg] = '0';
        man_str[i + is_neg + 1] = '\0';

        outsv = newSVpv(man_str, 0);
        Safefree(man_str);
        Safefree(exp_str);
        if(is_neg) s--;
        return outsv;
      }
      else if(zero_pad < 0) {
        /* We want, eg,  1.23625E2 to be returned as "123.625". *
         * This involves relocation of the decimal point.       */
        len = strlen(s);
        zero_pad--;
        if(is_neg) man_str[0] = '-';
        man_str[0 + is_neg] = s[0];
        man_str[1 + is_neg] = s[2]; /* s[1] is the decimal point */
        dec = 1; /* set to 0 when the decimal point is encountered */
        for(i = 2; i < len; i++) {
           if(i == zero_pad + len) {
             man_str[i + is_neg] = '.';
             dec--;
           }
           else man_str[i + is_neg] = s[i + dec];
        }

        man_str[i + is_neg] = '\0';

        outsv = newSVpv(man_str, 0);
        Safefree(man_str);
        Safefree(exp_str);
        if(is_neg) s--;
        return outsv;
      }
    }

    len = strlen(s); /* now different to when initially set     *
                      * because 'E' has been replaced with '\0' */
    if(exponent < -4 || exponent >= 0) {
       if(is_neg) man_str[0] = '-';
      for(i = 0; i < len; i++) man_str[i + is_neg] = s[i];
      if(!exponent) {
        man_str[i + is_neg] = '\0';
        outsv = newSVpv(man_str, 0);
        Safefree(man_str);
        Safefree(exp_str);
        if(is_neg) s--;
        return outsv;
      }
      man_str[i + is_neg] = 'e';
      len = strlen(exp_str);
      if(exponent > 0) {
        man_str[i + 1 + is_neg] = '+';
        dec = i + 2 + is_neg;
        for(i = 0; i < len; i ++) man_str[dec + i] = exp_str[i];
        man_str[dec + i] = '\0';
        outsv = newSVpv(man_str, 0);
        Safefree(man_str);
        Safefree(exp_str);
        if(is_neg) s--;
        return outsv;
      }
      /* exponent < -4 */
      dec = i + 1 + is_neg;
      if(len == 2) {
        man_str[dec] = '-';
        man_str[dec + 1] = '0';
        man_str[dec + 2] = exp_str[1];
        man_str[dec + 3] = '\0';
      }
      else {
        for(i = 0; i < len; i++) man_str[dec + i] = exp_str[i];
        man_str[dec + i] = '\0';
      }
      outsv = newSVpv(man_str, 0);
      Safefree(man_str);
      Safefree(exp_str);
      if(is_neg) s--;
      return outsv;
    }
    /* exponent is in range -1 to -4 (inclusive). *
     * Return, eg 6.25E1 as "0.625". **************/
     if(is_neg) man_str[0] = '-';
     man_str[is_neg] = '0';
     man_str[1 + is_neg] = '.';
     zero_pad = -exponent;
     zero_pad --;
     for(i = 0; i < zero_pad; i++) man_str[i + 2 + is_neg] = '0';
     man_str[i + 2 + is_neg] = s[0];
     dec = i + 1 + is_neg;
     len = strlen(s);
     for(i = 2; i < len; i++) man_str[dec + i] = s[i];
     man_str[dec + i] = '\0';
     outsv = newSVpv(man_str, 0);
     Safefree(man_str);
     Safefree(exp_str);
     if(is_neg) s--;
     return outsv;
  }
  else {
    /*** NO DECIMAL POINT IN STRING ***/
    if(s[0] == 'I') {
      if(is_neg) return newSVpv("-inf", 0);
      else return newSVpv("inf", 0);
    }
    if(s[0] == 'N') {
      if(is_neg) {
        s--;
        croak("rubbish input of '%s'", s);
      }
      return newSVpv("nan", 0);
    }
    /* mantissa is single-digit */
    len = strlen(s);
    Newxz(exp_str, MAX_DEC_DIG + 6, char);
    if(exp_str == NULL) croak("Failed (in 'else' block) to allocate memory for exp_str in fmtpy function");
    for(i = 2; i <= len; i++) exp_str[i - 2] = s[i];
    exponent = atoi(exp_str);
    if(exponent < -9) {
      /* Return, eg, '5E-10' as '5e-10' */
      s[1] = 'e';
      if(is_neg) s--;
      Safefree(exp_str);
      return newSVpv(s, 0);
    }
    /* Put the string to return into exp_str */
    if(exponent < -4) {
      /* Return, eg, '5E-9' as '5e-09'. */
      if(is_neg) exp_str[0] = '-';
      exp_str[0 + is_neg] = s[0];
      exp_str[1 + is_neg] = 'e';
      exp_str[2 + is_neg] = '-';
      exp_str[3 + is_neg] = '0';
      exp_str[4 + is_neg] = s[3];
      exp_str[5 + is_neg] = '\0';
      outsv = newSVpv(exp_str, 0);
      Safefree(exp_str);
      if(is_neg) s--;
      return outsv;
    }

    if(exponent >= 0 && exponent <= MAX_DEC_DIG - 2) {
      /* Return, eg, '5E13' as '50000000000000.0' */
      if(is_neg) exp_str[0] = '-';
      exp_str[0 + is_neg] = s[0];
      for(dec = 0; dec < exponent; dec++) exp_str[1 + is_neg + dec] = '0';
      exp_str[1 + is_neg + dec] = '.';
      exp_str[2 + is_neg + dec] = '0';
      exp_str[3 + is_neg + dec] = '\0';

      outsv = newSVpv(exp_str, 0);
      Safefree(exp_str);
      if(is_neg) s--;
      return outsv;
    }

    if(exponent > MAX_DEC_DIG - 2) {
      /* Return, eg, '8E50' as '8e+50' */
      if(is_neg) exp_str[0] = '-';
      exp_str[0 + is_neg] = s[0];
      exp_str[1 + is_neg] = 'e';
      exp_str[2 + is_neg] = '+';
      for(dec = 2; dec < len; dec++) exp_str[dec + 1 + is_neg] = s[dec];
      exp_str[dec + 1 + is_neg] = '\0';
      outsv = newSVpv(exp_str, 0);
      Safefree(exp_str);
      if(is_neg) s--;
      return outsv;
    }

    /* Exponent is in  the range -1 to -4. We   *
     * want, eg, '7E-1' to be returned as '0.7' *
     * and '-9E-4' to be returned as '-0.0009'  */

    if(is_neg)  exp_str[0] = '-';
    exp_str[0 + is_neg] = '0';
    exp_str[1 + is_neg] = '.';
    for(dec = -1; dec > exponent; dec--)  exp_str[1 + is_neg - dec] = '0';
    exp_str[1 + is_neg - dec] = s[0];
    exp_str[2 + is_neg - dec] = '\0';

    outsv = newSVpv(exp_str, 0);
    Safefree(exp_str);
    if(is_neg) s--;
    return outsv;
  }
}


#line 390 "Ryu.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 534 "Ryu.c"

XS_EUPXS(XS_Math__Ryu__s2d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Ryu__s2d)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "buffer");
    {
	char *	buffer = (char *)SvPV_nolen(ST(0))
;
	double	RETVAL;
	dXSTARG;

	RETVAL = _s2d(buffer);
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Ryu_d2s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Ryu_d2s)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "nv");
    {
	SV *	nv = ST(0)
;
	SV *	RETVAL;
#line 392 "Ryu.xs"
  RETVAL = M_RYU_d2s (aTHX_ nv);
#line 568 "Ryu.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Ryu_ld2s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Ryu_ld2s)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "nv");
    {
	SV *	nv = ST(0)
;
	SV *	RETVAL;
#line 399 "Ryu.xs"
  RETVAL = ld2s (aTHX_ nv);
#line 588 "Ryu.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Ryu_q2s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Ryu_q2s)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "nv");
    {
	SV *	nv = ST(0)
;
	SV *	RETVAL;
#line 406 "Ryu.xs"
  RETVAL = q2s (aTHX_ nv);
#line 608 "Ryu.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Ryu__SvIOK); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Ryu__SvIOK)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	int	RETVAL;
	dXSTARG;

	RETVAL = _SvIOK(sv);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Ryu__SvNOK); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Ryu__SvNOK)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	int	RETVAL;
	dXSTARG;

	RETVAL = _SvNOK(sv);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Ryu__SvPOK); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Ryu__SvPOK)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	int	RETVAL;
	dXSTARG;

	RETVAL = _SvPOK(sv);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Ryu__SvIOKp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Ryu__SvIOKp)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	int	RETVAL;
	dXSTARG;

	RETVAL = _SvIOKp(sv);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Ryu_ryu_lln); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Ryu_ryu_lln)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 428 "Ryu.xs"
  RETVAL = ryu_lln (aTHX_ sv);
#line 709 "Ryu.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Ryu__compiler_has_uint128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Ryu__compiler_has_uint128)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _compiler_has_uint128();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Ryu__get_max_dec_dig); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Ryu__get_max_dec_dig)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _get_max_dec_dig();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Ryu_fmtpy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Ryu_fmtpy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "in");
    {
	SV *	in = ST(0)
;
	SV *	RETVAL;
#line 441 "Ryu.xs"
  RETVAL = fmtpy (aTHX_ in);
#line 765 "Ryu.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Math__Ryu); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Math__Ryu)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Math::Ryu::_s2d", XS_Math__Ryu__s2d);
        newXS_deffile("Math::Ryu::d2s", XS_Math__Ryu_d2s);
        newXS_deffile("Math::Ryu::ld2s", XS_Math__Ryu_ld2s);
        newXS_deffile("Math::Ryu::q2s", XS_Math__Ryu_q2s);
        newXS_deffile("Math::Ryu::_SvIOK", XS_Math__Ryu__SvIOK);
        newXS_deffile("Math::Ryu::_SvNOK", XS_Math__Ryu__SvNOK);
        newXS_deffile("Math::Ryu::_SvPOK", XS_Math__Ryu__SvPOK);
        newXS_deffile("Math::Ryu::_SvIOKp", XS_Math__Ryu__SvIOKp);
        newXS_deffile("Math::Ryu::ryu_lln", XS_Math__Ryu_ryu_lln);
        newXS_deffile("Math::Ryu::_compiler_has_uint128", XS_Math__Ryu__compiler_has_uint128);
        newXS_deffile("Math::Ryu::_get_max_dec_dig", XS_Math__Ryu__get_max_dec_dig);
        newXS_deffile("Math::Ryu::fmtpy", XS_Math__Ryu_fmtpy);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
